diff --git a/src/fsm.c b/src/fsm.c
index 603e8b440..c1f132a0c 100644
--- a/src/fsm.c
+++ b/src/fsm.c
@@ -65,11 +65,17 @@ static ni_bool_t		ni_ifworker_del_child_master(xml_node_t *);
 static void			ni_fsm_clear_hierarchy(ni_ifworker_t *);
 
 static void			ni_ifworker_update_client_state_control(ni_ifworker_t *w);
-static inline void		ni_ifworker_update_client_state_config(ni_ifworker_t *w);
+static void			ni_ifworker_update_client_state_config(ni_ifworker_t *w);
 static void			ni_ifworker_update_client_state_scripts(ni_ifworker_t *w);
+static void			ni_ifworker_update_client_state(ni_ifworker_t *w);
+static void			ni_ifworker_reset_client_state(ni_ifworker_t *w);
+
 static void			ni_fsm_events_destroy(ni_fsm_event_t **);
 static void			ni_fsm_process_event(ni_fsm_t *, ni_fsm_event_t *);
 
+static const ni_fsm_transition_t *	ni_fsm_transition_first(void);
+static const ni_fsm_transition_t *	ni_fsm_transition_next(const ni_fsm_transition_t *);
+static const ni_fsm_transition_t *	ni_fsm_transition_find_method(const char *);
 
 ni_fsm_t *
 ni_fsm_new(void)
@@ -1245,167 +1251,6 @@ ni_ifworker_resolve_reference(ni_fsm_t *fsm, xml_node_t *devnode, ni_ifworker_ty
 	return child;
 }
 
-static xml_node_t *
-__ni_generate_default_config(ni_ifworker_t *parent, const char *ifname)
-{
-	xml_node_t *link, *ipv4, *ipv6, *config = NULL;
-	xml_node_t *pconfig, *control, *port;
-
-	pconfig = parent->config.node;
-	control = xml_node_get_child(pconfig, NI_CLIENT_IFCONFIG_CONTROL);
-
-	/* Create <interface> */
-	if (!(config = xml_node_new(NI_CLIENT_IFCONFIG, NULL)))
-		goto error;
-	/* Add <name>$ifname</name> */
-	if (!xml_node_new_element(NI_CLIENT_IFCONFIG_MATCH_NAME, config, ifname))
-		goto error;
-	/* Add <link></link> */
-	if (!(link = xml_node_new(NI_CLIENT_IFCONFIG_LINK, config)))
-		goto error;
-	/* Add <ipv4></ipv4> and <ipv6></ipv6> */
-	if (!(ipv4 = xml_node_new(NI_CLIENT_IFCONFIG_IPV4, config)))
-		goto error;
-	 if (!(ipv6 = xml_node_new(NI_CLIENT_IFCONFIG_IPV6, config)))
-		 goto error;
-
-	switch (parent->iftype) {
-	/* for slaves */
-	case NI_IFTYPE_TEAM:
-	case NI_IFTYPE_BOND:
-		/*
-		 * STARTMODE="hotplug"
-		 * BOOTPROTO="none"
-		 */
-
-		/* Add <control></control> */
-		if (!(control = xml_node_new(NI_CLIENT_IFCONFIG_CONTROL, config)))
-			goto error;
-		/* Add <mode>hotplug</mode> */
-		if (!xml_node_new_element(NI_CLIENT_IFCONFIG_MODE, control, "hotplug"))
-			goto error;
-		if (!xml_node_new_element(NI_CLIENT_IFCONFIG_IP_ENABLED, ipv4, "false"))
-			 goto error;
-		if (!xml_node_new_element(NI_CLIENT_IFCONFIG_IP_ENABLED, ipv6, "false"))
-			 goto error;
-	break;
-
-	case NI_IFTYPE_OVS_BRIDGE:
-		/*
-		 * STARTMODE="$pstartmode"
-		 * BOOTPROTO="none"
-		 */
-
-		/* Clone <control> */
-		if (!xml_node_is_empty(control) && !xml_node_clone(control, config))
-			goto error;
-		if (!xml_node_new_element(NI_CLIENT_IFCONFIG_IP_ENABLED, ipv4, "false"))
-			 goto error;
-		if (!xml_node_new_element(NI_CLIENT_IFCONFIG_IP_ENABLED, ipv6, "false"))
-			 goto error;
-
-		xml_node_new_element("master", link, ni_linktype_type_to_name(NI_IFTYPE_OVS_SYSTEM));
-		port = xml_node_new("port", link);
-		xml_node_add_attr(port, "type", ni_linktype_type_to_name(parent->iftype));
-		xml_node_new_element("bridge", port, parent->name);
-	break;
-
-	case NI_IFTYPE_BRIDGE:
-		/*
-		 * STARTMODE="$pstartmode"
-		 * BOOTPROTO="none"
-		 */
-
-		/* Clone <control> */
-		if (!xml_node_is_empty(control) && !xml_node_clone(control, config))
-			goto error;
-		if (!xml_node_new_element(NI_CLIENT_IFCONFIG_IP_ENABLED, ipv4, "false"))
-			 goto error;
-		if (!xml_node_new_element(NI_CLIENT_IFCONFIG_IP_ENABLED, ipv6, "false"))
-			 goto error;
-	break;
-
-	/* lowerdevs */
-	case NI_IFTYPE_VLAN:
-	case NI_IFTYPE_MACVLAN:
-	case NI_IFTYPE_MACVTAP:
-		/*
-		 * STARTMODE="$pstartmode"
-		 * BOOTPROTO="static"
-		 */
-
-		/* Clone <control> */
-		if (!xml_node_is_empty(control) && !xml_node_clone(control, config))
-			goto error;
-		if (!xml_node_new_element(NI_CLIENT_IFCONFIG_IP_ENABLED, ipv4, "true"))
-			 goto error;
-		if (!xml_node_new_element(NI_CLIENT_IFCONFIG_ARP_VERIFY, ipv4, "true"))
-			 goto error;
-		if (!xml_node_new_element(NI_CLIENT_IFCONFIG_IP_ENABLED, ipv6, "true"))
-			 goto error;
-	break;
-
-	default:
-		goto error;
-	}
-
-	return config;
-
-error:
-	ni_error("%s: Unable to generate default XML config (parent type %s)",
-		ifname, ni_linktype_type_to_name(parent->iftype));
-	xml_node_free(config);
-	return NULL;
-}
-
-static void
-ni_ifworker_generate_default_config(ni_ifworker_t *parent, ni_ifworker_t *child)
-{
-	xml_node_t *config;
-
-	if (!parent || !parent->iftype || !parent->config.node ||
-			!child || ni_string_empty(child->name))
-		return;
-
-	if (parent->iftype == NI_IFTYPE_OVS_SYSTEM)
-		return;
-
-	ni_debug_application("%s: generating default config for %s child",
-			parent->name, child->name);
-
-	config = __ni_generate_default_config(parent, child->name);
-	if (config) {
-		ni_ifworker_set_config(child, config, parent->config.meta.origin);
-		xml_node_free(config);
-	}
-}
-
-static ni_bool_t
-ni_ifworker_add_child_master(xml_node_t *config, const char *name)
-{
-	xml_node_t *link, *master;
-
-	if (xml_node_is_empty(config) || ni_string_empty(name))
-		return FALSE;
-
-	if (!(link = xml_node_get_child(config, NI_CLIENT_IFCONFIG_LINK))) {
-		if (!(link = xml_node_new(NI_CLIENT_IFCONFIG_LINK, config)))
-			return FALSE;
-	}
-
-	if (!(master = xml_node_get_child(link, NI_CLIENT_IFCONFIG_MASTER))) {
-		if (!xml_node_new_element(NI_CLIENT_IFCONFIG_MASTER, link, name))
-			return FALSE;
-	}
-	else if (!ni_string_eq(master->cdata, name)) {
-		ni_error("Failed adding <master>%s</master> to <link> -"
-			"there is already one <master>%s</master>", name, master->cdata);
-		return FALSE;
-	}
-
-	return TRUE;
-}
-
 static ni_bool_t
 ni_ifworker_del_child_master(xml_node_t *config)
 {
@@ -1488,10 +1333,6 @@ ni_ifworker_add_child(ni_ifworker_t *parent, ni_ifworker_t *child, xml_node_t *d
 		}
 	}
 
-	/* Generate missed slave config if needed */
-	if (xml_node_is_empty(child->config.node))
-		ni_ifworker_generate_default_config(parent, child);
-
 	/* Check if this child is already owned by the given parent. */
 	for (i = 0; i < parent->children.count; ++i) {
 		if (parent->children.data[i] == child)
@@ -1613,7 +1454,7 @@ ni_ifworker_update_client_state_control(ni_ifworker_t *w)
 	}
 }
 
-static inline void
+static void
 ni_ifworker_update_client_state_config(ni_ifworker_t *w)
 {
 	if (w && w->object && !w->readonly) {
@@ -1634,6 +1475,59 @@ ni_ifworker_update_client_state_scripts(ni_ifworker_t *w)
 	}
 }
 
+static void
+ni_ifworker_update_client_state(ni_ifworker_t *w)
+{
+	ni_ifworker_update_client_state_control(w);
+	ni_ifworker_update_client_state_config(w);
+	ni_ifworker_update_client_state_scripts(w);
+}
+
+static inline void
+ni_ifworker_reset_client_state_control(ni_ifworker_t *w)
+{
+	ni_client_state_control_t ctrl;
+
+	if (w && w->object && !w->readonly) {
+		ni_client_state_control_init(&ctrl);
+		ni_call_set_client_state_control(w->object, &ctrl);
+		ni_client_state_control_debug(w->name, &ctrl, "remove");
+	}
+}
+
+static inline void
+ni_ifworker_reset_client_state_config(ni_ifworker_t *w)
+{
+	ni_client_state_config_t config;
+
+	if (w && w->object && !w->readonly) {
+		ni_client_state_config_init(&config);
+		ni_call_set_client_state_config(w->object, &config);
+		ni_client_state_config_debug(w->name, &config, "remove");
+	}
+}
+
+static inline void
+ni_ifworker_reset_client_state_scripts(ni_ifworker_t *w)
+{
+	ni_client_state_scripts_t scripts = { .node = NULL };
+
+	if (w && w->object && !w->readonly) {
+		ni_call_set_client_state_scripts(w->object, &scripts);
+		ni_debug_application("%s: %s <%s> %s", w->name,
+				"remove", NI_CLIENT_STATE_XML_NODE,
+				NI_CLIENT_STATE_XML_SCRIPTS_NODE);
+	}
+}
+
+static inline void
+ni_ifworker_reset_client_state(ni_ifworker_t *w)
+{
+	ni_ifworker_reset_client_state_control(w);
+	ni_ifworker_reset_client_state_config(w);
+	ni_ifworker_reset_client_state_scripts(w);
+}
+
 static inline ni_bool_t
 ni_ifworker_empty_config(ni_ifworker_t *w)
 {
@@ -1664,9 +1558,10 @@ ni_ifworker_set_state(ni_ifworker_t *w, unsigned int new_state)
 
 		if ((new_state == NI_FSM_STATE_DEVICE_READY) && w->object && !w->readonly) {
 			ni_call_clear_event_filters(w->object);
-			ni_ifworker_update_client_state_control(w);
-			ni_ifworker_update_client_state_scripts(w);
-			ni_ifworker_update_client_state_config(w);
+			if (prev_state > new_state)
+				ni_ifworker_reset_client_state(w);
+			else
+				ni_ifworker_update_client_state(w);
 		}
 
 		if (w->target_state == new_state)
@@ -1816,15 +1711,11 @@ ni_ifworker_refresh_client_state(ni_ifworker_t *w, ni_client_state_t *cs)
 	if (!w || !cs)
 		return;
 
+	ni_client_state_debug(w->name, cs, "refresh");
+
 	w->control.persistent = cs->control.persistent;
 	w->control.usercontrol = cs->control.usercontrol;
 
-	w->config.meta.uuid = cs->config.uuid;
-	w->config.meta.owner = cs->config.owner;
-	ni_ifworker_set_config_origin(w, cs->config.origin);
-
-	ni_client_state_debug(w->name, cs, "refresh");
-
 	if (!w->state.node)
 		w->state.node = xml_node_new(ni_ifworker_type_to_string(w->type), NULL);
 	if (cs->scripts.node) {
@@ -2315,7 +2206,7 @@ struct ni_ifworker_require_resolver {
 struct ni_ifworker_check_state_req_check {
 	ni_ifworker_check_state_req_check_t *	next;
 	ni_ifworker_t *				worker;
-	ni_ifworker_require_resolver_t		resolver;
+	ni_ifworker_require_resolver_t *	resolver;
 	ni_uint_range_t				state;
 };
 struct ni_ifworker_check_state_req {
@@ -2323,13 +2214,10 @@ struct ni_ifworker_check_state_req {
 	ni_ifworker_check_state_req_check_t *	check;
 };
 
-static void					ni_ifworker_require_resolver_free(ni_fsm_require_t *);
-static inline ni_ifworker_require_resolver_t *	ni_ifworker_require_resolver_cast(ni_fsm_require_t *req)
-{
-	if (!req || req->destroy_fn != ni_ifworker_require_resolver_free)
-		return NULL;
-	return (ni_ifworker_require_resolver_t *)req->user_data;
-}
+static ni_ifworker_require_resolver_t *		ni_ifworker_require_resolver_new(ni_ifworker_type_t type,
+								xml_node_t *node, xml_node_t *meta);
+static void					ni_ifworker_require_resolver_free(ni_ifworker_require_resolver_t *);
+
 static void					ni_ifworker_check_state_req_free(ni_fsm_require_t *);
 static inline ni_ifworker_check_state_req_t *	ni_ifworker_check_state_req_cast(ni_fsm_require_t *req)
 {
@@ -2339,7 +2227,7 @@ static inline ni_ifworker_check_state_req_t *	ni_ifworker_check_state_req_cast(n
 }
 
 static inline ni_ifworker_check_state_req_check_t *
-ni_ifworker_check_state_req_check_new(ni_ifworker_t *cw, ni_ifworker_type_t cwtype,
+ni_ifworker_config_check_state_req_check_new(ni_ifworker_t *cw, ni_ifworker_type_t cwtype,
 					xml_node_t *cwnode, xml_node_t *cwmeta,
 					unsigned int min_state, unsigned int max_state)
 {
@@ -2347,9 +2235,21 @@ ni_ifworker_check_state_req_check_new(ni_ifworker_t *cw, ni_ifworker_type_t cwty
 
 	check = xcalloc(1, sizeof(*check));
 	check->worker = cw ?  ni_ifworker_get(cw) : NULL;
-	check->resolver.cwtype = cwtype;
-	check->resolver.cwnode = cwnode ? xml_node_clone_ref(cwnode) : NULL;
-	check->resolver.cwmeta = cwmeta ? xml_node_clone_ref(cwmeta) : NULL;
+	check->resolver = ni_ifworker_require_resolver_new(cwtype, cwnode, cwmeta);
+	check->state.min = min_state;
+	check->state.max = max_state;
+	return check;
+}
+
+static inline ni_ifworker_check_state_req_check_t *
+ni_ifworker_system_check_state_req_check_new(ni_ifworker_t *cw,
+					unsigned int min_state, unsigned int max_state)
+{
+	ni_ifworker_check_state_req_check_t *check;
+
+	check = xcalloc(1, sizeof(*check));
+	check->worker = cw ?  ni_ifworker_get(cw) : NULL;
+	check->resolver = NULL;
 	check->state.min = min_state;
 	check->state.max = max_state;
 	return check;
@@ -2359,13 +2259,9 @@ static inline void
 ni_ifworker_check_state_req_check_free(ni_ifworker_check_state_req_check_t *check)
 {
 	if (check) {
-		if (check->resolver.cwmeta) {
-			xml_node_free(check->resolver.cwmeta);
-			check->resolver.cwmeta = NULL;
-		}
-		if (check->resolver.cwnode) {
-			xml_node_free(check->resolver.cwnode);
-			check->resolver.cwnode = NULL;
+		if (check->resolver) {
+			ni_ifworker_require_resolver_free(check->resolver);
+			check->resolver = NULL;
 		}
 		if (check->worker) {
 			ni_ifworker_release(check->worker);
@@ -2461,7 +2357,7 @@ ni_ifworker_require_netif_resolve(ni_fsm_t *fsm, ni_ifworker_t *w, ni_ifworker_t
 
 static ni_ifworker_t *
 ni_ifworker_require_resolve(ni_fsm_t *fsm, ni_ifworker_t *w, ni_ifworker_type_t type,
-				xml_node_t *node, xml_node_t *meta)
+		xml_node_t *node, xml_node_t *meta)
 {
 	switch (type) {
 	case NI_IFWORKER_TYPE_NETDEV:
@@ -2475,11 +2371,9 @@ ni_ifworker_require_resolve(ni_fsm_t *fsm, ni_ifworker_t *w, ni_ifworker_type_t
 }
 
 static void
-ni_ifworker_require_resolver_free(ni_fsm_require_t *req)
+ni_ifworker_require_resolver_free(ni_ifworker_require_resolver_t *resolver)
 {
-	ni_ifworker_require_resolver_t *resolver;
-
-	if ((resolver = ni_ifworker_require_resolver_cast(req))) {
+	if (resolver) {
 		if (resolver->cwmeta) {
 			xml_node_free(resolver->cwmeta);
 			resolver->cwmeta = NULL;
@@ -2490,49 +2384,24 @@ ni_ifworker_require_resolver_free(ni_fsm_require_t *req)
 		}
 		free(resolver);
 	}
-	if (req)
-		req->user_data = NULL;
-}
-
-static ni_bool_t
-ni_ifworker_require_resolver_test(ni_fsm_t *fsm, ni_ifworker_t *w, ni_fsm_require_t *req)
-{
-	ni_ifworker_require_resolver_t *resolver;
-
-	if (!(resolver = ni_ifworker_require_resolver_cast(req)))
-		return TRUE;
-
-	ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_APPLICATION, "%s: %s trying to resolve %s-reference",
-			w->name, __func__, resolver->cwtype == NI_IFWORKER_TYPE_NETDEV ? "netif" : "modem");
-
-	if (!ni_ifworker_require_resolve(fsm, w, resolver->cwtype, resolver->cwnode, resolver->cwmeta))
-		return FALSE;
-
-	ni_ifworker_require_resolver_free(req);
-	return TRUE;
 }
 
-static inline void
-ni_ifworker_require_resolver_new(ni_fsm_t *fsm, ni_ifworker_t *w, ni_ifworker_type_t type,
-					xml_node_t *node, xml_node_t *meta)
+static ni_ifworker_require_resolver_t *
+ni_ifworker_require_resolver_new(ni_ifworker_type_t type, xml_node_t *node, xml_node_t *meta)
 {
 	ni_ifworker_require_resolver_t *resolver;
-	ni_fsm_require_t *req;
-
-	ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_APPLICATION, "%s: %s to resolve a %s-reference",
-			w->name, __func__, type == NI_IFWORKER_TYPE_NETDEV ? "netif" : "modem");
 
-	req = ni_fsm_require_new(ni_ifworker_require_resolver_test, ni_ifworker_require_resolver_free);
 	resolver = xcalloc(1, sizeof(*resolver));
-	resolver->cwtype = type;
-	resolver->cwnode = xml_node_clone_ref(node);
-	resolver->cwmeta = xml_node_clone_ref(meta);
-	req->user_data = resolver;
-	ni_fsm_require_list_insert(&w->fsm.check_state_req_list, req);
+	if (resolver) {
+		resolver->cwtype = type;
+		resolver->cwnode = xml_node_clone_ref(node);
+		resolver->cwmeta = xml_node_clone_ref(meta);
+	}
+	return resolver;
 }
 
 static ni_bool_t
-ni_ifworker_check_state_req_test(ni_fsm_t *fsm, ni_ifworker_t *w, ni_fsm_require_t *req)
+ni_ifworker_config_check_state_req_test(ni_fsm_t *fsm, ni_ifworker_t *w, ni_fsm_require_t *req)
 {
 	ni_ifworker_check_state_req_check_t *check;
 	ni_ifworker_check_state_req_t *csr;
@@ -2544,18 +2413,16 @@ ni_ifworker_check_state_req_test(ni_fsm_t *fsm, ni_ifworker_t *w, ni_fsm_require
 		return FALSE;
 
 	for (check = csr->check; check; check = check->next) {
-		if (check->worker)
+		if (check->worker || !check->resolver)
 			continue;
 
-		cw = ni_ifworker_require_resolve(fsm, w, check->resolver.cwtype,
-				check->resolver.cwnode, check->resolver.cwmeta);
+		cw = ni_ifworker_require_resolve(fsm, w, check->resolver->cwtype,
+				check->resolver->cwnode,  check->resolver->cwmeta);
 		if (cw) {
 			/* switch over to the worker */
 			check->worker = ni_ifworker_get(cw);
-			xml_node_free(check->resolver.cwmeta);
-			check->resolver.cwmeta = NULL;
-			xml_node_free(check->resolver.cwnode);
-			check->resolver.cwnode = NULL;
+			ni_ifworker_require_resolver_free(check->resolver);
+			check->resolver = NULL;
 		}
 	}
 
@@ -2632,6 +2499,59 @@ ni_ifworker_check_state_req_test(ni_fsm_t *fsm, ni_ifworker_t *w, ni_fsm_require
 	return all_required_ok && state_reached > 0;
 }
 
+static ni_bool_t
+ni_ifworker_system_check_state_req_test(ni_fsm_t *fsm, ni_ifworker_t *w, ni_fsm_require_t *req)
+{
+	ni_ifworker_check_state_req_check_t *check;
+	ni_ifworker_check_state_req_t *csr;
+	ni_bool_t all_required_ok = TRUE;
+	ni_ifworker_t *cw;
+
+	if (!(csr = ni_ifworker_check_state_req_cast(req)))
+		return FALSE;
+
+	for (check = csr->check; check; check = check->next) {
+		ni_fsm_state_t wait_for_state;
+
+		if (!(cw = check->worker))
+			continue;
+
+		if (!ni_fsm_ifworker_by_ifindex(fsm, cw->ifindex)) {
+			ni_debug_application("%s: worker %s has been deleted",
+					w->name, cw->name);
+			continue;
+		}
+		if (!cw->device) {
+			ni_debug_application("%s: worker %s device has been deleted",
+					w->name, cw->name);
+			continue;
+		}
+		if (cw->failed) {
+			ni_debug_application("%s: worker %s failed", w->name, cw->name);
+			continue;
+		}
+
+		if (cw->fsm.state < check->state.min) {
+			wait_for_state = check->state.min;
+		} else if (cw->fsm.state > check->state.max) {
+			wait_for_state = check->state.max;
+		} else {
+			ni_debug_application("%s: worker %s reached %s state %s..%s",
+					w->name, cw->name, csr->method,
+					ni_ifworker_state_name(check->state.min),
+					ni_ifworker_state_name(check->state.max));
+			continue;
+		}
+
+		ni_debug_application("%s: waiting for worker %s to reach %s state %s",
+				w->name, cw->name, csr->method,
+				ni_ifworker_state_name(wait_for_state));
+		all_required_ok = FALSE;
+	}
+
+	return all_required_ok;
+}
+
 static void
 ni_ifworker_check_state_req_free(ni_fsm_require_t *req)
 {
@@ -2647,34 +2567,34 @@ ni_ifworker_check_state_req_free(ni_fsm_require_t *req)
 }
 
 static ni_fsm_require_t *
-ni_ifworker_check_state_req_new(const char *method, ni_ifworker_t *cw,
-			ni_ifworker_type_t cwtype, xml_node_t *cwnode, xml_node_t *cwmeta,
-			unsigned int min_state, unsigned int max_state)
+ni_ifworker_check_state_req_new(ni_ifworker_check_state_req_check_t *check,
+		const char *method, ni_fsm_require_fn_t *test_fn)
 {
-	ni_ifworker_check_state_req_check_t *check;
 	ni_ifworker_check_state_req_t *csr;
 	ni_fsm_require_t *req;
 
+	if (!check || ni_string_empty(method))
+		return NULL;
+
 	csr = xcalloc(1, sizeof(*csr));
 	ni_string_dup(&csr->method, method);
 
-	check = ni_ifworker_check_state_req_check_new(cw, cwtype, cwnode, cwmeta, min_state, max_state);
 	ni_ifworker_check_state_req_check_list_append(csr, check);
 
-	req = ni_fsm_require_new(ni_ifworker_check_state_req_test, ni_ifworker_check_state_req_free);
+	req = ni_fsm_require_new(test_fn, ni_ifworker_check_state_req_free);
 	req->user_data = csr;
 	return req;
 }
 
 static void
-ni_ifworker_add_check_state_req(ni_ifworker_t *w, const char *method, ni_ifworker_t *cw,
+ni_ifworker_add_config_check_state_req(ni_ifworker_t *w, const char *method, ni_ifworker_t *cw,
 			ni_ifworker_type_t cwtype, xml_node_t *cwnode, xml_node_t *cwmeta,
 			unsigned int min_state, unsigned int max_state)
 {
+	ni_ifworker_check_state_req_check_t *check;
 	ni_fsm_require_t *req;
 
 	for (req = w->fsm.check_state_req_list; req; req = req->next) {
-		ni_ifworker_check_state_req_check_t *check;
 		ni_ifworker_check_state_req_t *csr;
 
 		if (!(csr = ni_ifworker_check_state_req_cast(req)))
@@ -2686,17 +2606,51 @@ ni_ifworker_add_check_state_req(ni_ifworker_t *w, const char *method, ni_ifworke
 		if (cw && ni_ifworker_check_state_req_check_find_worker(csr, cw))
 			continue; /* try to not add worker check twice */
 
-		check = ni_ifworker_check_state_req_check_new(cw, cwtype, cwnode, cwmeta, min_state, max_state);
+		check = ni_ifworker_config_check_state_req_check_new(cw,
+				cwtype, cwnode, cwmeta, min_state, max_state);
+		ni_ifworker_check_state_req_check_list_append(csr, check);
+	}
+
+	check = ni_ifworker_config_check_state_req_check_new(cw,
+			cwtype, cwnode, cwmeta, min_state, max_state);
+	req = ni_ifworker_check_state_req_new(check, method,
+			ni_ifworker_config_check_state_req_test);
+	ni_fsm_require_list_insert(&w->fsm.check_state_req_list, req);
+}
+
+static void
+ni_ifworker_add_system_check_state_req(ni_ifworker_t *w, const char *method,
+		ni_ifworker_t *cw, unsigned int min_state, unsigned int max_state)
+{
+	ni_ifworker_check_state_req_check_t *check;
+	ni_fsm_require_t *req;
+
+	for (req = w->fsm.check_state_req_list; req; req = req->next) {
+		ni_ifworker_check_state_req_t *csr;
+
+		if (!(csr = ni_ifworker_check_state_req_cast(req)))
+			continue;
+
+		if (!ni_string_eq(csr->method, method))
+			continue;
+
+		if (cw && ni_ifworker_check_state_req_check_find_worker(csr, cw))
+			continue; /* try to not add worker check twice */
+
+		check = ni_ifworker_system_check_state_req_check_new(cw,
+				min_state, max_state);
 		ni_ifworker_check_state_req_check_list_append(csr, check);
-		return;
 	}
 
-	req = ni_ifworker_check_state_req_new(method, cw, cwtype, cwnode, cwmeta, min_state, max_state);
+	check = ni_ifworker_system_check_state_req_check_new(cw,
+			min_state, max_state);
+	req = ni_ifworker_check_state_req_new(check, method,
+			ni_ifworker_system_check_state_req_test);
 	ni_fsm_require_list_insert(&w->fsm.check_state_req_list, req);
 }
 
 static void
-__ni_ifworker_get_check_state_reqs_for_method(ni_ifworker_t *w, ni_fsm_transition_t *action)
+ni_ifworker_get_check_state_reqs_for_method(ni_ifworker_t *w, ni_fsm_transition_t *action)
 {
 	ni_fsm_require_t **list, *req;
 
@@ -2719,13 +2673,6 @@ __ni_ifworker_get_check_state_reqs_for_method(ni_ifworker_t *w, ni_fsm_transitio
 				w->name, csr->method, cw ? cw->name : "unresolved",
 				ni_ifworker_state_name(check->state.min),
 				ni_ifworker_state_name(check->state.max));
-
-#if 0			/* really? */
-			if (cw && check->state.min > cw->target_range.min)
-				cw->target_range.min = check->state.min;
-			if (cw && check->state.max < cw->target_range.max)
-				cw->target_range.max = check->state.max;
-#endif
 		}
 
 		/* Move this requirement to the action's req list */
